#include <bits/stdc++.h>
using namespace std;
long long N,NIZ[200005],K,X,Y,x,y,Q;
int main(){
  cin>>N;
  for(int i=1;i<=N;i++){
    K=0;
    scanf("%lld",&X);
    if(X<Y)K=1;
    NIZ[i]=NIZ[i-1]+K;
    Y=X;
  }
  for(int i=1;i<=N;i++){
    cout<<NIZ[i]<<" ";
  }
  cin>>Q;
  for(int i=1;i<=Q;i++){
   scanf("%lld",&x);
   scanf("%lld",&y);
  if(NIZ[y]-NIZ[x]>1)printf("NE\n");
  else printf("DA\n");
  }
 return 0;
}